Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices
Imports System.Drawing


'//////////////////////////////////////////////////////////////
''' <summary>
''' DirectShowp̃[eBeBW[(TvOo֌W)łB
''' </summary>
''' <remarks></remarks>
Public Module DSUSampleGrabber

    ''' <summary>
    ''' t[Pʂł̉摜擾񋟂NXłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Class FrameCapture

        '----------------------------------------------------------
        'Jf[^
#Region "萔"

        ''' <summary>Lv`tB^ɕt閼̂łB</summary>
        Public Const CAPTUREFILTERCAPTION As String = "CAMERA"

        ''' <summary>TvOotB^ɕt閼̂łB</summary>
        Public Const SAMPLEGRABBERFILTERCAPTION As String = "SAMPLEGRABBER"

        ''' <summary>TvÕsNZ`\萔łB</summary>
        Public Enum PIXELFORMATYPE
            ''' <summary>sNZ`słB</summary>
            Unknown = 0
            ''' <summary>WrbgR`lŁAΐԂ̏Ŋi[`łB</summary>
            BGR24 = 3
            ''' <summary>WrbgS`lŁAΐԂ̏Ŋi[`łB`l͖܂B</summary>
            BGR32 = 4
        End Enum

#End Region

#Region "Cxg"

        ''' <summary>
        ''' ĐɏI[ɒBꍇɌĂяo܂B
        ''' </summary>
        ''' <param name="LoopCount">[v</param>
        ''' <param name="PlayStop">Đ𑱂ꍇFalse,Đ~ꍇTrue</param>
        ''' <remarks></remarks>
        Public Event OnLoop(ByVal LoopCount As Integer, ByRef PlayStop As Boolean)

#End Region

        '----------------------------------------------------------
        'f[^
#Region "veNgϐ"
        Protected mGrp As IGraphBuilder     'Ot
        Protected mFlt As IBaseFilter       'Lv`tB^
        Protected mPin As IPin              'Lv`tB^̏o̓s
        Protected mSmp As ISampleGrabber    'TvOotB^
        Protected mFmt As PIXELFORMATYPE    'sNZ`

        Protected mSize As Size             'fTCY
        Protected mVisible As Boolean       'Jf\邩H
        Protected mBuff As IntPtr           'rbg}bv擾pobt@

        Protected mIsLoop As Boolean        '[vĐsH
        Protected mLoopThread As System.Threading.Thread    '[vĎXbh
        Protected mLoopCount As Integer     '[vK
#End Region

        '----------------------------------------------------------
        '----------------------------------------------------------

        '----------------------------------------------------------
#Region "RXgN^/fXgN^"

        ''' <summary>
        ''' NX܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub New()

        End Sub

#End Region

        '----------------------------------------------------------
#Region "J"

        ''' <summary>
        ''' ݗp\ȃJ̏񋓂܂B
        ''' </summary>
        ''' <returns>J񂪊i[ꂽFILTERINFORMATION^̃Xg</returns>
        ''' <remarks></remarks>
        Public Shared Function GetCameraName() As List(Of FILTERINFORMATION)
            Return EnumFilters(DSConst.FilterCategoryGUID.CLSID_VideoInputDeviceCategory)
        End Function

#End Region

        '----------------------------------------------------------
#Region "e̎擾Ɛݒ"

        ''' <summary>Ot擾܂B</summary>
        Public ReadOnly Property Graph() As IGraphBuilder
            Get
                Return mGrp
            End Get
        End Property

        ''' <summary>Ot̃Lv`tB^擾܂B</summary>
        Public ReadOnly Property Filter() As IBaseFilter
            Get
                Return mFlt
            End Get
        End Property

        ''' <summary>Ot̃Lv`tB^o̓s擾܂B</summary>
        Public ReadOnly Property FilterPin() As IPin
            Get
                Return mPin
            End Get
        End Property

        ''' <summary>Ot̃TvOotB^擾܂B</summary>
        Public ReadOnly Property SampleGrabber() As ISampleGrabber
            Get
                Return mSmp
            End Get
        End Property

        ''' <summary>Jf\Ԃ擾Eݒ肵܂B</summary>
        Public Property Visible() As Boolean
            Get
                Return mVisible
            End Get
            Set(ByVal value As Boolean)

                'ݒ̕ۑ
                mVisible = value

                '_ݒ
                SetVisible()

            End Set
        End Property

        ''' <summary>_̕\Ԃݒ肵܂B</summary>
        Private Sub SetVisible()

            '_ݒ
            If mGrp IsNot Nothing Then

                Dim vw As IVideoWindow = CType(mGrp, IVideoWindow)
                If mVisible Then
                    '\
                    vw.put_Visible(-1)
                    vw.put_AutoShow(-1)
                Else
                    '\
                    vw.put_Visible(0)
                    vw.put_AutoShow(0)
                End If

            End If

        End Sub

        ''' <summary>
        ''' fTCY擾܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property VideoSize() As Size
            Get
                Return mSize
            End Get
        End Property

        ''' <summary>
        ''' 摜TCYij擾܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property Width() As Integer
            Get
                Return mSize.Width
            End Get
        End Property

        ''' <summary>
        ''' 摜TCYicj擾܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property Height() As Integer
            Get
                Return mSize.Height
            End Get
        End Property

        ''' <summary>
        ''' 摜擾pobt@̃|C^擾܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property ReadBuffer() As IntPtr
            Get
                Return mBuff
            End Get
        End Property


        ''' <summary>
        ''' sNZ`擾܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property PixelFormat() As PIXELFORMATYPE
            Get
                Return mFmt
            End Get
        End Property

        ''' <summary>
        ''' Đ̃[v񐔂擾܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property LoopCount() As Integer
            Get
                Return mLoopCount
            End Get
        End Property

#End Region

        '----------------------------------------------------------
#Region "Ot/"

        ''' <summary>
        ''' Jԍw肵ăOt𐶐܂B
        ''' </summary>
        ''' <param name="Index">Jԍ</param>
        ''' <param name="Width">fTCY</param>
        ''' <param name="Height">fcTCY</param>
        ''' <param name="PinIndex">sԍ</param>
        ''' <param name="FormatType">Lv`sNZtH[}bg`</param>
        ''' <remarks>TCYȗꂽꍇ(0ȉ̏ꍇ܂)Ã݂TCYgp܂B</remarks>
        Public Sub CreateGraph(ByVal Index As Integer, Optional ByVal Width As Integer = 0, Optional ByVal Height As Integer = 0, Optional ByVal PinIndex As Integer = 0, Optional ByVal FormatType As PIXELFORMATYPE = PIXELFORMATYPE.BGR24)

            Try

                '݂̃Ot
                Release()

                'VKOt
                Dim grp As IGraphBuilder = CreateNewGraph()

                'Lv`tB^Otɒǉ
                Dim flt As IBaseFilter = AddFilter(grp, DSConst.FilterCategoryGUID.CLSID_VideoInputDeviceCategory, Index, CAPTUREFILTERCAPTION)

                'o̓s擾
                Dim pin As IPin = FindPin(flt, PinIndex, PIN_DIRECTION.PINDIR_OUTPUT)

                'o̓tH[}bgI
                SelectFormat(pin, Width, Height)

                'Ot
                CreateGraph(grp, flt, pin, FormatType)

            Catch ex As Exception
                Throw New DSException(ex, "t[擾p̃OtɎs܂B")
            End Try

        End Sub

        ''' <summary>
        ''' [UIJŃOt𐶐܂B
        ''' </summary>
        ''' <param name="GrpInfo">_CAOō쐬ꂽOt</param>
        ''' <param name="FormatType">Lv`sNZtH[}bg`</param>
        ''' <remarks></remarks>
        Public Sub CreateGraph(ByVal GrpInfo As DSUSelectCameraDialog.VIDEOCAPTUREGRAPHINFO, Optional ByVal FormatType As PIXELFORMATYPE = PIXELFORMATYPE.BGR24)

            Try

                '`FbN
                If (GrpInfo.Graph Is Nothing) Or _
                   (GrpInfo.Filter Is Nothing) Or _
                   (GrpInfo.Pin Is Nothing) Then
                    Throw New DSException("słB")
                End If

                'Ot
                CreateGraph(GrpInfo.Graph, GrpInfo.Filter, GrpInfo.Pin, FormatType)

            Catch ex As Exception
                Throw New DSException(ex, "t[擾p̃OtɎs܂B")
            End Try

        End Sub

        ''' <summary>
        ''' [UɃJƃTCYIăOt𐶐܂B
        ''' </summary>
        ''' <param name="FormatType">Lv`sNZtH[}bg`</param>
        ''' <remarks></remarks>
        Public Sub CreateGraph(Optional ByVal FormatType As PIXELFORMATYPE = PIXELFORMATYPE.BGR24)

            '_CAO\
            Dim dlg As New DSUSelectCameraDialog
            Dim ginfo As New DSUSelectCameraDialog.VIDEOCAPTUREGRAPHINFO
            If dlg.ShowDialog(ginfo) <> Windows.Forms.DialogResult.OK Then
                Exit Sub
            End If

            'Ot
            CreateGraph(ginfo.Graph, ginfo.Filter, ginfo.Pin, FormatType)

        End Sub

        ''' <summary>
        ''' t@C摜ǂݍރOt𐶐܂B
        ''' </summary>
        ''' <param name="Filename">摜t@C</param>
        ''' <param name="FormatType">Lv`sNZtH[}bg`</param>
        ''' <remarks></remarks>
        Public Sub CreateGraph(ByVal Filename As String, Optional ByVal FormatType As PIXELFORMATYPE = PIXELFORMATYPE.BGR24)

            Try

                '݂̃Ot
                Release()

                'VKOt
                Dim grp As IGraphBuilder = CreateNewGraph()

                '\[XtB^Otɒǉ
                Dim flt As IBaseFilter = Nothing
                grp.AddSourceFilter(Filename, CAPTUREFILTERCAPTION, flt)

                'o̓s擾
                Dim pin As IPin = FindPin(flt, 0, PIN_DIRECTION.PINDIR_OUTPUT)

                'Ot
                CreateGraph(grp, flt, pin, FormatType)

                'Đ̓[v
                mIsLoop = True

            Catch ex As Exception
                Throw New DSException(ex, "t[擾p̃OtɎs܂B")
            End Try


        End Sub

        ''' <summary>
        ''' Ot𐶐܂B
        ''' </summary>
        ''' <param name="Grp">Ot</param>
        ''' <param name="Filter">Lv`tB^</param>
        ''' <param name="Pin">o̓s</param>
        ''' <param name="FormatType">Lv`sNZtH[}bg`</param>
        ''' <remarks></remarks>
        Public Sub CreateGraph(ByVal Grp As IGraphBuilder, ByVal Filter As IBaseFilter, ByVal Pin As IPin, Optional ByVal FormatType As PIXELFORMATYPE = PIXELFORMATYPE.BGR24)

            Try
                '݂̃Ot
                Release()

                '̕ۑƃ`FbN
                mGrp = Grp
                mFlt = Filter
                mPin = Pin
                If (mGrp Is Nothing) Or (mFlt Is Nothing) Or (mPin Is Nothing) Then Throw New DSException("słB")

                'OtɃTvOoǉ
                Dim smpflt As IBaseFilter
                smpflt = InsertSampleGrabberFilter(FormatType)

                'tB^ڑ
                Dim sipin As IPin = FindPin(smpflt, 0, PIN_DIRECTION.PINDIR_INPUT)
                Dim sopin As IPin = FindPin(smpflt, 0, PIN_DIRECTION.PINDIR_OUTPUT)
                mGrp.Connect(Pin, sipin)
                mGrp.Render(sopin)

                'TvOoł̃TvOJn
                mSmp.SetBufferSamples(True)

                '_ݒ
                SetVisible()

                'rfITCY擾
                Dim bv As IBasicVideo2 = CType(mGrp, IBasicVideo2)
                bv.GetVideoSize(mSize.Width, mSize.Height)

            Catch ex As Exception

                mGrp = Nothing
                mFlt = Nothing
                mPin = Nothing
                mSmp = Nothing
                mFmt = PIXELFORMATYPE.Unknown

                Throw New DSException(ex, "Ot𐶐ł܂B")

            End Try

        End Sub

        ''' <summary>
        ''' Ot܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub Release()

            'eC^[tF[X/CX^X
            mSmp = Nothing
            mFlt = Nothing
            mPin = Nothing
            ReleaseInstance(mGrp)

            '擾pobt@̉
            If mBuff <> IntPtr.Zero Then
                Marshal.FreeHGlobal(mBuff)
            End If
            mBuff = IntPtr.Zero

            'NA
            mSize = New Size(0, 0)

        End Sub

        ''' <summary>
        ''' o̓s̏o͌`I܂B
        ''' </summary>
        ''' <param name="Pin">Ώۃs</param>
        ''' <param name="Width">TCY</param>
        ''' <param name="Height">cTCY</param>
        ''' <remarks>
        ''' tH[}bg̗񋓂œTCY΁ÃtH[}bgݒ肷B
        ''' ݂ȂꍇÃ݂tH[}bg̃TCYύXĐݒ肷B
        ''' </remarks>
        Private Sub SelectFormat(ByVal Pin As IPin, ByVal Width As Integer, ByVal Height As Integer)

            'O`FbN
            If (Width <= 0) Or (Height <= 0) Then Exit Sub 'tH[}bggp

            Dim mt As AM_MEDIA_TYPE = Nothing
            Dim dataptr As IntPtr = IntPtr.Zero
            Dim vinfo As New DSVIDEOINFOHEADER
            Try

                'IAMStreamConfigC^[tF[X擾
                Dim cfg As IAMStreamConfig = CType(Pin, IAMStreamConfig)

                'tH[}bg擾
                Dim cnt As Integer = 0
                Dim sz As Integer = 0
                cfg.GetNumberOfCapabilities(cnt, sz)

                'f[^p̈m
                dataptr = Marshal.AllocHGlobal(sz)

                '
                For x As Integer = 0 To cnt - 1

                    'xԖڂ̃tH[}bg擾
                    cfg.GetStreamCaps(x, mt, dataptr)

                    'TCYmF
                    If CompGUIDString(mt.formatType.ToString, FormatTypeGUID.FORMAT_VideoInfo) Then
                        vinfo = PtrToStructure(Of DSVIDEOINFOHEADER)(mt.formatPtr)
                        If (vinfo.BmiHeader.Width = Width) And (vinfo.BmiHeader.Height = Height) Then
                            'ړĨTCY

                            'tH[}bgI
                            cfg.SetFormat(mt)

                            Exit Try
                        End If
                    End If

                    '
                    If mt IsNot Nothing Then DeleteMediaType(mt)
                Next

                '݂̃tH[}bg擾
                mt = GetFormat(Pin)
                vinfo = PtrToStructure(Of DSVIDEOINFOHEADER)(mt.formatPtr)
                vinfo.BmiHeader.Width = Width
                vinfo.BmiHeader.Height = Height
                SetFormat(Pin, mt)

                '
                DeleteMediaType(mt)

            Catch ex As Exception
                Throw New DSException(ex, "tH[}bg̐ݒɎs܂B")

            Finally
                If dataptr <> IntPtr.Zero Then Marshal.FreeHGlobal(dataptr)
                If mt IsNot Nothing Then DeleteMediaType(mt)

            End Try

        End Sub

        ''' <summary>
        ''' OtɃTvOotB^ǉ܂B
        ''' </summary>
        ''' <param name="FormatType"></param>
        ''' <remarks></remarks>
        Private Function InsertSampleGrabberFilter(ByVal FormatType As PIXELFORMATYPE) As IBaseFilter

            'TvOotB^̃CX^X쐬
            Dim smpflt As IBaseFilter
            smpflt = CreateFilter(DSConst.FilterGUID.CLSID_SampleGrabber)

            'ISampleGrabberC^[tF[X擾
            mSmp = CType(smpflt, ISampleGrabber)

            'TvOotB^̓͌`ݒ
            Dim mt As New AM_MEDIA_TYPE
            mt.majorType = New Guid(MediaTypeGUID.MEDIATYPE_Video)      'rfI
            Select Case FormatType
                Case PIXELFORMATYPE.BGR24
                    mt.subType = New Guid(MediaTypeGUID.MEDIASUBTYPE_RGB24)     'RGB24
                Case PIXELFORMATYPE.BGR32
                    mt.subType = New Guid(MediaTypeGUID.MEDIASUBTYPE_RGB32)     'RGB32
                Case Else
                    Throw New DSException("sNZ`słB")
            End Select
            mFmt = FormatType
            mSmp.SetMediaType(mt)

            'Otɒǉ
            mGrp.AddFilter(smpflt, SAMPLEGRABBERFILTERCAPTION)

            Return smpflt
        End Function

        ''' <summary>
        ''' ̃Otɉ摜Lv`ptB^ǉ܂B
        ''' </summary>
        ''' <param name="Grp">ɂȂOt</param>
        ''' <remarks></remarks>
        Public Sub AttachGraph(ByVal Grp As IGraphBuilder, Optional ByVal FormatType As PIXELFORMATYPE = PIXELFORMATYPE.BGR24)

            'rfI_̌
            Dim ret As IBaseFilter = Nothing
            Dim flt As IBaseFilter = Nothing
            Dim eflt As IEnumFilters = Nothing
            Try
                'tB^̗񋓊Jn
                Grp.EnumFilters(eflt)

                '
                Dim fc As Integer = 0
                Do While eflt.Next(1, flt, fc) = 0
                    If fc = 0 Then Exit Do

                    If TypeOf flt Is IVideoWindow Then
                        '
                        ret = flt
                        Exit Do
                    End If

                    ReleaseInstance(flt)
                Loop

            Catch ex As Exception
                ret = Nothing

            Finally
                '񋓏I
                ReleaseInstance(eflt)
            End Try
            If ret Is Nothing Then
                Throw New DSException("rfI_܂B")
            End If

            'Lv`pOt
            Dim prevflt As IBaseFilter = Nothing
            Try
                'rfI_̓̓s̐ڑ(tB^)̃s擾
                Dim ripin As IPin = FindPin(flt, 0, PIN_DIRECTION.PINDIR_INPUT)
                Dim popin As IPin = Nothing
                ripin.ConnectedTo(popin)

                'tB^̎擾
                Dim pi As New PIN_INFO
                popin.QueryPinInfo(pi)
                prevflt = pi.Filter

                'tB^o̓š݌`擾
                Dim cfg As IAMStreamConfig
                cfg = TryCast(popin, IAMStreamConfig)
                If cfg Is Nothing Then Throw New DSException("IAMStreamConfigC^[tF[X擾ł܂B")
                Dim mt As New AM_MEDIA_TYPE
                cfg.GetFormat(mt)

                'ؒf
                Grp.Disconnect(popin)
                Grp.Disconnect(ripin)

                'rfI_폜
                Grp.RemoveFilter(flt)
                ReleaseInstance(flt)
                flt = Nothing

                'tB^o̓š`ݒ
                cfg.SetFormat(mt)

                'Otč쐬
                CreateGraph(Grp, prevflt, popin)

            Catch ex As Exception
                Throw New DSException(ex, "Lv`pOtɐł܂B" + vbCrLf + "RF" + ex.Message)

            Finally

                If prevflt IsNot Nothing Then
                    Marshal.ReleaseComObject(prevflt)
                End If

            End Try

        End Sub

#End Region

#Region "Ot"

        ''' <summary>
        ''' OtsATvOJn܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub CaptureStart()

            Try
                'ԃ`FbN
                If mGrp Is Nothing Then Throw New DSException("OtĂ܂B")

                'TvOoł̃TvOJn
                mSmp.SetBufferSamples(True)

                'OtJn
                GraphPlay(mGrp)

                '[vĐ
                mLoopCount = 0
                If mIsLoop Then
                    mLoopThread = PlayLoopStart(mGrp, AddressOf CaptureLoop)
                End If

            Catch ex As Exception

            End Try

        End Sub

        ''' <summary>
        ''' Ot~܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub CaptureStop()

            Try
                'ԃ`FbN
                If mGrp Is Nothing Then Exit Sub

                'OtJn
                GraphStop(mGrp)

                '[vĐI
                If mLoopThread IsNot Nothing Then
                    PlayLoopStop(mLoopThread)
                    mLoopThread = Nothing
                End If

            Catch ex As Exception

            End Try

        End Sub

        ''' <summary>
        ''' Ot̍ĐI[ɒBƂɌĂяo܂B
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Protected Overridable Function CaptureLoop() As Boolean

            '[vJE^Z
            mLoopCount += 1

            'Cxg
            Dim flg As Boolean = False
            RaiseEvent OnLoop(mLoopCount, flg)

            Return flg
        End Function


#End Region

        '----------------------------------------------------------
#Region "t[擾"

        ''' <summary>
        ''' ݂̉摜擾܂B
        ''' </summary>
        ''' <param name="Timeout">^CAEgl</param>
        ''' <returns>擾łꍇ擾f[^̃oCgA擾łȂꍇ0</returns>
        ''' <remarks>TvOoɉ摜ȂꍇA0Ԃ܂B</remarks>
        Public Function GetCurrentBuffer(Optional ByVal Timeout As Integer = 0) As Integer

            Dim sz As Integer = 0
            Dim st As Integer = System.Environment.TickCount
            Dim et As Integer = 0
            Do

                Try

                    '摜f[^TCY擾
                    mSmp.GetCurrentBuffer(sz, IntPtr.Zero)

                    'obt@m
                    If mBuff = IntPtr.Zero Then
                        mBuff = Marshal.AllocHGlobal(sz)
                    End If

                    '摜f[^擾
                    mSmp.GetCurrentBuffer(sz, mBuff)

                    '
                    Exit Do

                Catch ex As COMException
                    If ex.ErrorCode = DSConst.DirectShowHRESULT.VFW_E_WRONG_STATE Then
                        '܂MĂȂ

                        'EFCg
                        System.Threading.Thread.Sleep(10)

                        '擾ȂƂ
                        sz = 0
                    Else
                        Throw
                    End If

                End Try

                '^CAEg
                et = System.Environment.TickCount
                If (et - st > Timeout) Or (et < st) Then Exit Do
            Loop

            Return sz
        End Function

        ''' <summary>
        ''' ݂̉摜擾܂B
        ''' </summary>
        ''' <param name="Ptr">i[̃|C^</param>
        ''' <param name="Timeout">^CAEgl</param>
        ''' <returns>擾łꍇ擾f[^̃oCgA擾łȂꍇ0</returns>
        ''' <remarks>TvOoɉ摜ȂꍇA0Ԃ܂B</remarks>
        Public Function GetCurrentBuffer(ByVal Ptr As IntPtr, Optional ByVal Timeout As Integer = 0) As Integer

            Dim sz As Integer = 0
            Dim st As Integer = System.Environment.TickCount
            Dim et As Integer = 0
            Do
                Try
                    '摜f[^TCY擾
                    mSmp.GetCurrentBuffer(sz, IntPtr.Zero)

                    '摜f[^擾
                    mSmp.GetCurrentBuffer(sz, Ptr)

                    '
                    Exit Do

                Catch ex As COMException
                    If ex.ErrorCode = DSConst.DirectShowHRESULT.VFW_E_WRONG_STATE Then
                        '܂MĂȂ

                        'EFCg
                        System.Threading.Thread.Sleep(10)

                        '擾ȂƂ
                        sz = 0
                    Else
                        Throw
                    End If

                End Try

                '^CAEg
                et = System.Environment.TickCount
                If (et - st > Timeout) Or (et < st) Then Exit Do
            Loop

            Return sz
        End Function

        ''' <summary>
        ''' ݂̉摜擾Arbg}bv쐬܂B
        ''' </summary>
        ''' <returns>쐬ꂽrbg}bv</returns>
        ''' <remarks></remarks>
        Public Function QueryFrameBitmap() As Bitmap

            Try

                '݂̉摜擾
                Dim sz As Integer = GetCurrentBuffer()

                'rbg}bv쐬
                Dim bmp As Bitmap
                Select Case mFmt
                    Case PIXELFORMATYPE.BGR24
                        bmp = New Bitmap(mSize.Width, mSize.Height, mSize.Width * 3, Imaging.PixelFormat.Format24bppRgb, mBuff)
                    Case PIXELFORMATYPE.BGR32
                        bmp = New Bitmap(mSize.Width, mSize.Height, mSize.Width * 4, Imaging.PixelFormat.Format32bppRgb, mBuff)
                    Case Else
                        bmp = New Bitmap(mSize.Width, mSize.Height)
                End Select

                '㉺]
                bmp.RotateFlip(RotateFlipType.RotateNoneFlipY)

                Return bmp

            Catch ex As Exception

                Throw New DSException(ex, "rbg}bv擾ł܂B")

            End Try

        End Function

#End Region

    End Class

End Module
