Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices
Imports DShowLib

'//////////////////////////////////////////////////////////////
'g`f[^i[obt@NX
'EŐV̈ʂ̂݃obt@OAÂf[^͔jB(Oobt@)
Public Class WaveBuffer
    Implements ISampleGrabberCB         'TvOotB^̃R[obNƂċ@\

    '----------------------------------------------------------
    'Jf[^

    '----------------------------------------------------------
    'f[^
    Private mBuffSize As Integer        'obt@TCY
    Private mBuff As Byte()             'obt@
    Private mBuffLock As New Object     'obt@bNIuWFNg
    Private mTopIndex As Integer        'f[^擪ʒu
    Private mDataCount As Integer       'f[^
    Private mTopBlockNumber As Integer  '擪ubNԍ

    Private mChannelCount As Integer    '`l
    Private mBitLength As Integer       'rbg(rbg)
    Private mSamplePerSec As Integer    'TvO[g

    Private mBitLengthByte As Integer   'rbg(oCg)
    Private mBlockSize As Integer       'ubN


    '----------------------------------------------------------
    '----------------------------------------------------------

    'RXgN^
    '
    '@ChannelCount              `l(1 or 2)
    '@BitLength                 rbg(8 or 16)
    '@SamplePerSec              bԂ̃Tv
    '@BuffTime                  obt@O鎞(b)
    '
    Public Sub New(ByVal ChannelCount As Integer, ByVal BitLength As Integer, ByVal SamplePerSec As Integer, ByVal BuffTime As Integer)

        '̕ۑ
        mChannelCount = ChannelCount
        mBitLength = BitLength
        mSamplePerSec = SamplePerSec
        mBitLengthByte = BitLength \ 8
        mBlockSize = mChannelCount * mBitLengthByte
        mBuffSize = mBlockSize * mSamplePerSec * BuffTime

        '̈m
        ReDim mBuff(mBuffSize - 1)

        '
        ClearData()

    End Sub

    'fXgN^
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

    '----------------------------------------------------------

    'ubNTCY
    Public ReadOnly Property BlockSize() As Integer
        Get
            Return mBlockSize
        End Get
    End Property

    'f[^
    Public ReadOnly Property DataCount() As Integer
        Get
            Return mDataCount
        End Get
    End Property


    '----------------------------------------------------------

    'f[^NA
    '
    'Eobt@ɂB
    Public Sub ClearData()

        SyncLock mBuffLock
            mTopIndex = 0
            mDataCount = 0
            mTopBlockNumber = 0
        End SyncLock

    End Sub

    'f[^̒ǉ
    '
    '@DataPtr                  f[^i[Ă̈̃|C^
    '@Count                    f[^(oCg)
    '
    'ECount̓ubNTCYPʂł邱ƁB
    Public Sub AddData(ByVal DataPtr As IntPtr, ByVal Count As Integer)

        SyncLock mBuffLock

            '`FbN
            If (Count Mod mBlockSize) <> 0 Then Throw New Exception("ǉf[^ubNPʂł܂B")
            If Count > mBuffSize Then Throw New Exception("obt@TCY܂B")

            '󂫂邩H
            If Count > mBuffSize - mDataCount Then
                '󂫂Ȃ

                'j
                DropData(Count)

            End If

            ']
            Dim sz As Integer = 0
            Dim wp As Integer
            Do While Count > 0

                ']TCY
                sz = Count
                wp = (mTopIndex + mDataCount) Mod mBuffSize
                If wp + sz > mBuffSize Then
                    sz = mBuffSize - wp
                End If

                ']
                Marshal.Copy(DataPtr, mBuff, wp, sz)
                mDataCount += sz
                Count -= sz
                DataPtr = CType(DataPtr.ToInt32 + sz, IntPtr)

            Loop

        End SyncLock

    End Sub

    'f[^̔j
    '
    '@Count                    jf[^(oCg)
    '
    'ECount̓ubNTCYPʂł邱ƁB
    Public Sub DropData(ByVal Count As Integer)

        SyncLock mBuffLock

            '`FbN
            If mDataCount < Count Then
                '݂̃f[^ȏj悤Ƃ

                'NA
                Me.ClearData()

                Return
            End If

            'j
            mTopIndex = (mTopIndex + Count) Mod mBuffSize
            mDataCount -= Count

            '擪ubNԍ̍XV
            mTopBlockNumber += Count \ mBlockSize

        End SyncLock


    End Sub

    '----------------------------------------------------------

    'g`f[^̎擾
    '
    '@BlockNumber              擪ubNԍ
    '@Data                     g`f[^i[̈
    '@Count                    擾g`f[^(Tv)
    '
    'EData͗̈悪mۂĂ邱ƁB
    'Ẽf[^`Ɋ֌WȂADataɊi[f[^͕16rbgɕϊB
    'Ef[^ȂɂẮA0xf[^i[B
    Public Sub ReadWave(ByVal BlockNumber As Integer, ByRef Data() As WaveData, ByVal Count As Integer)

        SyncLock mBuffLock

            'ǍJnʒu
            Dim blk As Integer = BlockNumber - mTopBlockNumber  'obt@̃ubNԍ
            Dim idx As Integer = blk * mBlockSize               'obt@̃CfbNX
            If idx < 0 Then idx = 0
            Dim endblk As Integer = mTopBlockNumber + mDataCount \ mBlockSize   'obt@̍ŏIubNԍ+1

            '荞
            Select Case mBitLength
                Case 8
                    For y As Integer = 0 To Count - 1
                        If (0 <= blk) And (blk < endblk) Then
                            'obt@ɂ

                            'e`l̃f[^擾
                            For x As Integer = 0 To mChannelCount - 1
                                Data(y).Level(x) = (PeekByte(idx) - 128) * 256
                                idx += 1
                            Next
                        Else
                            'obt@ɂȂ

                            '0xf[^i[
                            Data(y).Level0 = 0
                            Data(y).Level1 = 0
                        End If
                    Next

                Case 16
                    For y As Integer = 0 To Count - 1
                        If (0 <= blk) And (blk < endblk) Then
                            'obt@ɂ

                            'e`l̃f[^擾
                            For x As Integer = 0 To mChannelCount - 1
                                Data(y).Level(x) = PeekShort(idx)
                                idx += 2
                            Next
                        Else
                            'obt@ɂȂ

                            '0xf[^i[
                            Data(y).Level0 = 0
                            Data(y).Level1 = 0
                        End If
                    Next

            End Select


        End SyncLock

    End Sub

    '---------------------------------------------------------

    'obt@̃f[^擾
    '()
    '@Index                    obt@̃CfbNX(0`DataCount-1)
    '߂l
    '@obt@̃f[^
    '()
    'ËׁACfbNX`FbN͍sȂB
    'E߂l͂̊֐Integer^ƂȂB
    Public Function PeekByte(ByVal Index As Integer) As Integer
        Return mBuff((mTopIndex + Index) Mod mBuffSize)
    End Function
    Public Function PeekShort(ByVal Index As Integer) As Integer
        Dim ret As Integer
        ret = mBuff((mTopIndex + Index) Mod mBuffSize)
        ret += mBuff((mTopIndex + Index + 1) Mod mBuffSize) * 256
        If ret > 32767 Then ret -= 65536
        Return ret
    End Function


    '---------------------------------------------------------
    'ISampleGrabberCBC^[tF[X̎

    'ETvOotB^Ƀf[^͂тɌĂяoB
    Public Function BufferCB(ByVal SampleTime As Double, ByVal pBuffer As System.IntPtr, ByVal BufferLen As Integer) As Integer Implements ISampleGrabberCB.BufferCB
        AddData(pBuffer, BufferLen)
        Return 0
    End Function

    'gpFobt@O[ĥݑΉ
    Public Function SampleCB(ByVal SampleTime As Double, ByVal pSample As IMediaSample) As Integer Implements ISampleGrabberCB.SampleCB
        Return 0
    End Function

End Class


'//////////////////////////////////////////////////////////////
'g`f[^
Public Structure WaveData

    '---------------------------------------------------------
    'Jf[^
    Public Level0 As Integer        '`lÕf[^
    Public Level1 As Integer        '`lP̃f[^

    '---------------------------------------------------------

    'e`l̃x
    Public Property Level(ByVal Channel As Integer) As Integer
        Get
            Select Case Channel
                Case 0 : Return Level0
                Case 1 : Return Level1
            End Select
            Return 0
        End Get
        Set(ByVal value As Integer)
            Select Case Channel
                Case 0 : Level0 = value
                Case 1 : Level1 = value
            End Select
        End Set
    End Property

    'mf[^̎擾
    Public ReadOnly Property MonoLevel() As Integer
        Get
            Return (Level0 + Level1) \ 2
        End Get
    End Property

End Structure

