Option Strict On
Option Explicit On

'//////////////////////////////////////////////////////////////
'URTCϊNXipj
Public Class DCT

    '----------------------------------------------------------
    'Jf[^
    Public Const DEFBIAS As Integer = 2048

    '----------------------------------------------------------
    'Jf[^
    Private mCount As Integer       'f[^
    Private mWC As Integer(,)       'ϊW
    Private mBias As Integer        'oCAX

    '----------------------------------------------------------

    'RXgN^
    Public Sub New()

    End Sub

    'fXgN^
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

    '----------------------------------------------------------

    '
    '
    '@Count            f[^i2̏搔ł邱Ɓj
    '@Bias             oCAXl
    '߂l
    '@True             s
    '@False            
    '
    'Ef[^́AA^Cł1024炢EB(P4-2.4GHzj
    '@܂傫ƋAĂȂȂ̂ŒӁB
    'EoCAXl͐^ŏ_ȉ̒ľׂWB
    '@傫Ɛxオ邪AI[o[t[̉\łĂB
    Public Function Initialize(ByVal Count As Integer, Optional ByVal Bias As Integer = DEFBIAS) As Boolean

        '`FbN
        If Count < 2 Then Throw New Exception("f[^Ȃ܂B")
        If (Count And (Count - 1)) <> 0 Then Throw New Exception("f[^͂Q̏搔ɂKv܂B")

        'oCAXlۑ
        mBias = Bias

        'ϊWp̈m
        mCount = Count
        ReDim mWC(mCount - 1, mCount - 1)

        'ϊWvZ
        Dim x, y As Integer
        Dim ww As Double
        For x = 0 To mCount - 1
            ww = Math.Sqrt(2.0# / CSng(mCount))
            If x = 0 Then ww *= Math.Sqrt(0.5#)
            For y = 0 To mCount - 1
                mWC(x, y) = CInt(Bias * ww * Math.Cos((Math.PI * (2.0# * y + 1.0#) * x) / (2.0# * mCount)))
            Next
        Next

    End Function

    '----------------------------------------------------------
    'ϊ
    '
    '@Src              f[^
    '@Dst              ϊf[^
    Public Sub Translation(ByRef Src As Integer(), ByRef Dst As Integer())

        Dim x, y, s As Integer
        For x = 0 To mCount - 1
            s = 0
            For y = 0 To mCount - 1
                s += Src(y) * mWC(x, y)
            Next
            Dst(x) = s \ mBias
        Next

    End Sub

    '----------------------------------------------------------
    'tϊ
    '
    '@Src              f[^
    '@Dst              ϊf[^
    Public Sub Inversion(ByRef Src As Integer(), ByRef Dst As Integer())

        Dim x, y, s As Integer
        For x = 0 To mCount - 1
            s = 0
            For y = 0 To mCount - 1
                s += Src(y) * mWC(y, x)
            Next
            Dst(x) = s \ mBias
        Next

    End Sub


End Class
